unit WybKombEulera;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Graphics, katy_eulera;

type
  TWyborKombinacjiEulera = class(TGraphicControl)
  private
    fKombinacja : Tkombinacja;
    fWgStarych  : Boolean;
    fOnChange   : TNotifyEvent;
    procedure setKombinacja(value:Tkombinacja);
    procedure setWgStarych(value:Boolean);
    procedure Change;
  protected
    procedure Paint; override;
    procedure MouseDown(Button:TMouseButton; Shift:TShiftState; X,Y:Integer); override;
  public
  published
    property Kombinacja : Tkombinacja   read fKombinacja  write setKombinacja;
    property WgStarych  : Boolean       read fWgStarych   write setWgStarych;
    property OnChange   : TNotifyEvent  read fOnChange    write fOnChange;
    property Font;
    property Align;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('PJank', [TWyborKombinacjiEulera]);
end;

procedure TWyborKombinacjiEulera.setKombinacja;
begin
  if (fKombinacja <> value) then begin
    fKombinacja:= value;
    Change;
  end;
end;

procedure TWyborKombinacjiEulera.setWgStarych;
begin
  if (fWgStarych <> value) then begin
    fWgStarych:= value;
    Change;
  end;
end;

procedure TWyborKombinacjiEulera.Change;
begin
  Invalidate;
  if Assigned(OnChange) then OnChange(Self);
end;


procedure TWyborKombinacjiEulera.Paint;
var R: TRect;
    b: Boolean;
    k: Tkombinacja;
    s: string;
begin
  for b:= Low(b) to High(b) do
  for k:= Low(k) to High(k) do begin
    // ustalenie recta
    R:= Rect(0, 0, Width div 2, Height div (High(k)-Low(k)+1));
    if (not b) then OffsetRect(R, R.Right, 0);
    OffsetRect(R, 0, (Ord(k)-Low(k))*R.Bottom);
    // ustawienie kolorw
    Canvas.Font:= Font;
    if (b=WgStarych) and (k=Kombinacja) then begin
      Canvas.Brush.Color:= clBlue;
      Canvas.Font.Color:= clYellow;
    end
    else begin
      Canvas.Brush.Color:= clBlack;
      Canvas.Font.Color:= clWhite;
    end;
    // wydrukowanie tekstu
    s:= OpisKombinacji(k,b);
    Canvas.TextRect(R, (R.Left+R.Right-Canvas.TextWidth(s)) div 2, R.Top, s);
  end;
end;

procedure TWyborKombinacjiEulera.MouseDown;
begin
  if (Button = mbLeft) then begin
    WgStarych:= (X < Width div 2);
    Kombinacja:= Low(TKombinacja) + (Y div (Height div (High(TKombinacja)-Low(TKombinacja)+1)));
  end;
  inherited;
end;

end.
